﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Prism.Regions;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.Events;
using Microsoft.Practices.Prism.ViewModel;
using Microsoft.Practices.Unity;

using System.ComponentModel;
using System.Linq.Expressions;
using System.Collections.ObjectModel;
using System.Windows.Input;
using Microsoft.Practices.Prism.Commands;

namespace SplashDemo
{
    public class RegionSetViewModel : NotificationObject
    {
        
        private List<MenuDataItem> _MenuDataItem;
        public List<MenuDataItem> userMenuItems
        {
            get { return _MenuDataItem; }
            set
            {
                _MenuDataItem = value;
                RaisePropertyChanged("userMenuItems");
            }
        }


        public DelegateCommand<string> SwitchPageCommand { get; private set; }

        public RegionSetViewModel()
        {
            userMenuItems = GetUserMainMenuItem("TestUser");
            SwitchPageCommand = new DelegateCommand<string>(executeMethod: param => MenuItemClick(param), canExecuteMethod: delegate { return true; });

        }

        public List<MenuDataItem> GetUserMainMenuItem(string userID)
        {
            List<MenuDataItem> mItems = new List<MenuDataItem>();

            MenuDataItem mn = new MenuDataItem();
            mn.MenuId = 1001;
            mn.MenuName = "New";
            mItems.Add(mn);

            List<MenuDataItem> subItems = new List<MenuDataItem>();
            MenuDataItem mchild = new MenuDataItem();
            mchild.MenuId = 2001;
            mchild.MenuName = "FileOne";
            subItems.Add(mchild);

            mchild = new MenuDataItem();
            mchild.MenuId = 2002;
            mchild.MenuName = "FileSecond";
            subItems.Add(mchild);

            mn = new MenuDataItem();
            mn.MenuId = 1005;
            mn.MenuName = "Open";
            mn.Children = subItems;
            mItems.Add(mn);

            mn = new MenuDataItem();
            mn.MenuId = 1002;
            mn.MenuName = "Save";
            mItems.Add(mn);


            mn = new MenuDataItem();
            mn.MenuId = 1003;
            mn.MenuName = "Close";
            mItems.Add(mn);

            return mItems;
        }
        

        public void MenuItemClick(object menuID)
        {
          

        }

        
    }
}
